import { HttpClient } from '@angular/common/http';
import { RestAspect, ConfigService } from '@yukawa/chain-base-angular-client';
import { Injectable } from '@angular/core';
import { map } from 'rxjs/operators';

/**
 * @fileoverview added by tsickle
 * Generated from: core/aspect.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function DocsManagementAspect() { }
if (false) {
    /**
     * @param {?} filter
     * @return {?}
     */
    DocsManagementAspect.prototype.loadFile = function (filter) { };
    /**
     * @param {?} filter
     * @return {?}
     */
    DocsManagementAspect.prototype.queryFiles = function (filter) { };
    /**
     * @param {?} fileId
     * @return {?}
     */
    DocsManagementAspect.prototype.deleteFile = function (fileId) { };
    /**
     * @param {?} fileId
     * @return {?}
     */
    DocsManagementAspect.prototype.downloadFile = function (fileId) { };
}

/**
 * @fileoverview added by tsickle
 * Generated from: core/event.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @deprecated
 * @record
 */
function FileEvent() { }

/**
 * @fileoverview added by tsickle
 * Generated from: client/docs-management.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
//import {map} from "rxjs/operators";
class DocsManagementService extends RestAspect {
    /**
     * @param {?} http
     * @param {?} configService
     */
    constructor(http, configService) {
        super(http, configService, configService.formatUrl('docsServiceUrl'));
        this.http = http;
        this.configService = configService;
    }
    /**
     * @param {?} filter
     * @return {?}
     */
    loadFile(filter) {
        //   return super.load<FileInfo>(`${this.formatServiceUrl('')}?id=${filter.fileId}`)
        //     .pipe(map(value => this.checkNotNull(value)));
        //return super.load(`${this.formatServiceUrl('')}?id=${filter.fileId}`);
        // @toDo * [ww] use query param or replace uri comp
        return this.load(this.formatServiceUrl('/files') + filter.fileId)
            .pipe(map((/**
         * @param {?} value
         * @return {?}
         */
        value => this.checkNotNull(value))));
    }
    // protected formatServiceUrl(path : string = '') {
    //     return this.serviceUrl + path;
    // }
    /**
     * @param {?} filter
     * @return {?}
     */
    queryFiles(filter) {
        return this.query(this.formatServiceUrl('/files/query'), filter);
    }
    /**
     * @param {?} fileId
     * @return {?}
     */
    deleteFile(fileId) {
        return this.http.delete(this.formatServiceUrl('/files') + fileId);
    }
    /**
     * @param {?} fileId
     * @return {?}
     */
    downloadFile(fileId) {
        return this.http.get(this.formatServiceUrl('/download') + fileId, { responseType: "blob" });
        // return this.download(this.formatServiceUrl('/download') + fileId, null,{method:'get'});
    }
}
DocsManagementService.decorators = [
    { type: Injectable }
];
/** @nocollapse */
DocsManagementService.ctorParameters = () => [
    { type: HttpClient },
    { type: ConfigService }
];
if (false) {
    /**
     * @type {?}
     * @protected
     */
    DocsManagementService.prototype.http;
    /**
     * @type {?}
     * @protected
     */
    DocsManagementService.prototype.configService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: yukawa-chain-docs-angular-core.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { DocsManagementService };
//# sourceMappingURL=yukawa-chain-docs-angular-core.js.map
