import { __extends } from 'tslib';
import { HttpClient } from '@angular/common/http';
import { ConfigService, RestAspect } from '@yukawa/chain-base-angular-client';
import { Injectable } from '@angular/core';
import { map } from 'rxjs/operators';

/**
 * @fileoverview added by tsickle
 * Generated from: core/aspect.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function DocsManagementAspect() { }
if (false) {
    /**
     * @param {?} filter
     * @return {?}
     */
    DocsManagementAspect.prototype.loadFile = function (filter) { };
    /**
     * @param {?} filter
     * @return {?}
     */
    DocsManagementAspect.prototype.queryFiles = function (filter) { };
    /**
     * @param {?} fileId
     * @return {?}
     */
    DocsManagementAspect.prototype.deleteFile = function (fileId) { };
    /**
     * @param {?} fileId
     * @return {?}
     */
    DocsManagementAspect.prototype.downloadFile = function (fileId) { };
}

/**
 * @fileoverview added by tsickle
 * Generated from: core/event.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @deprecated
 * @record
 */
function FileEvent() { }

/**
 * @fileoverview added by tsickle
 * Generated from: client/docs-management.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
//import {map} from "rxjs/operators";
var DocsManagementService = /** @class */ (function (_super) {
    __extends(DocsManagementService, _super);
    function DocsManagementService(http, configService) {
        var _this = _super.call(this, http, configService, configService.formatUrl('docsServiceUrl')) || this;
        _this.http = http;
        _this.configService = configService;
        return _this;
    }
    /**
     * @param {?} filter
     * @return {?}
     */
    DocsManagementService.prototype.loadFile = /**
     * @param {?} filter
     * @return {?}
     */
    function (filter) {
        var _this = this;
        //   return super.load<FileInfo>(`${this.formatServiceUrl('')}?id=${filter.fileId}`)
        //     .pipe(map(value => this.checkNotNull(value)));
        //return super.load(`${this.formatServiceUrl('')}?id=${filter.fileId}`);
        // @toDo * [ww] use query param or replace uri comp
        return this.load(this.formatServiceUrl('/files') + filter.fileId)
            .pipe(map((/**
         * @param {?} value
         * @return {?}
         */
        function (value) { return _this.checkNotNull(value); })));
    };
    // protected formatServiceUrl(path : string = '') {
    //     return this.serviceUrl + path;
    // }
    // protected formatServiceUrl(path : string = '') {
    //     return this.serviceUrl + path;
    // }
    /**
     * @param {?} filter
     * @return {?}
     */
    DocsManagementService.prototype.queryFiles = 
    // protected formatServiceUrl(path : string = '') {
    //     return this.serviceUrl + path;
    // }
    /**
     * @param {?} filter
     * @return {?}
     */
    function (filter) {
        return this.query(this.formatServiceUrl('/files/query'), filter);
    };
    /**
     * @param {?} fileId
     * @return {?}
     */
    DocsManagementService.prototype.deleteFile = /**
     * @param {?} fileId
     * @return {?}
     */
    function (fileId) {
        return this.http.delete(this.formatServiceUrl('/files') + fileId);
    };
    /**
     * @param {?} fileId
     * @return {?}
     */
    DocsManagementService.prototype.downloadFile = /**
     * @param {?} fileId
     * @return {?}
     */
    function (fileId) {
        return this.http.get(this.formatServiceUrl('/download') + fileId, { responseType: "blob" });
        // return this.download(this.formatServiceUrl('/download') + fileId, null,{method:'get'});
    };
    DocsManagementService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    DocsManagementService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: ConfigService }
    ]; };
    return DocsManagementService;
}(RestAspect));
if (false) {
    /**
     * @type {?}
     * @protected
     */
    DocsManagementService.prototype.http;
    /**
     * @type {?}
     * @protected
     */
    DocsManagementService.prototype.configService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: yukawa-chain-docs-angular-core.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { DocsManagementService };
//# sourceMappingURL=yukawa-chain-docs-angular-core.js.map
